//g++ -o ./icon-desk ./icon-desk.c -lXinerama -lXft  -lX11 -lImlib2 -lXmu  `pkg-config --cflags --libs ib-2.0` `giblib-config --cflags --libs` -lcurl -lpng
//#include "config.h"
#include <libexif/exif-data.h>
#include <stdio.h>
#include <gnu-versions.h>
#include <curl/curl.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <netdb.h>
#include <string.h>
#include <limits.h>
#include <X11/Xfuncproto.h>
#include <X11/Intrinsic.h>	/* Xlib, Xutil, Xresource, Xfuncproto */
#include <X11/X.h>
#include <X11/Xproto.h>
#include <X11/Xlib.h>
#include <X11/extensions/XShm.h>
#include <X11/Xutil.h>
#include <X11/extensions/shape.h>
#include <X11/Xatom.h>
#include <X11/Xos.h>
//#include <dmalloc.h>
//#include <X11/keysym.h>
#include <X11/Xresource.h>
#ifdef HAVE_LIBXINERAMA
#include <X11/extensions/Xinerama.h>
#endif				/* HAVE_LIBXINERAMA */
#include <stdlib.h>
#include <unistd.h>
#include <ctype.h>
#include <sys/stat.h>
#include <pwd.h>
#include <sys/time.h>
#include <sys/un.h>
#include <errno.h>
#include <dirent.h>
#include <stdarg.h>
#include <signal.h>
#include <sys/wait.h>
#include <math.h>
#include <Imlib2.h>
#include <giblib/giblib.h>
#include <png.h>
#include <stdarg.h>
#include <stdarg.h>
#include <stdlib.h>
#include <unistd.h>
#include <math.h>

#include "./other_src/debug.h"
#include "./other_src/exif.h"
#include "./other_src/exif_nikon.h"
#include "./other_src/feh_png.h"
#include "./other_src/structs.h"
#include "./other_src/filelist.h"
#include "./other_src/getopt.h"
#include "./other_src/md5.h"
#include "./other_src/timers.h"
#include "./other_src/options.h"
#include "./other_src/signals.h"
#include "./other_src/utils.h"
#include "./other_src/wallpaper.h"
#include "./other_src/winwidget.h"
#include "./other_src/index.h"
#include "./other_src/menu.h"
#include "./other_src/feh.h"
#include "./other_src/collage.c"
#include "./other_src/exif.c"
#include "./other_src/feh_png.c"
#include "./other_src/filelist.c"
#include "./other_src/getopt.c"
#include "./other_src/getopt1.c"
#include "./other_src/imlib.c"
#include "./other_src/index.c"
#include "./other_src/list.c"
#include "./other_src/main.c"
#include "./other_src/md5.c"
#include "./other_src/menu.c"
#include "./other_src/options.c"
#include "./other_src/signals.c"
#include "./other_src/slideshow.c"
#include "./other_src/timers.c"
#include "./other_src/utils.c"
#include "./other_src/wallpaper.c"
#include "./other_src/winwidget.c"


#define random(x) (rand()%x)  


Display            *disp;
Window              win;
Window              win2;
Visual             *vis;
Colormap            cm;
int                 depth;
XSetWindowAttributes attr;

int main(int argc, char **argv)
{
  int                 w, h, x, y;
  Imlib_Image         im_bg = NULL;
  XEvent              ev;
  const char         *display_name = getenv("DISPLAY");
  Imlib_Image         buffer;
  Imlib_Image         back;
  Imlib_Image         bigback;
  Imlib_Font          font;
  Imlib_Color_Range   range;
  int  text_w, text_h;
  if (display_name == NULL)
    display_name = ":0";
  disp = XOpenDisplay(display_name);
  if (disp == NULL)
  {
    fprintf(stderr, "Can't open display %s\n", display_name);
    return 1;
  }
  int screen=DefaultScreen(disp);
  int screenWidth=0;
  screenWidth=XDisplayWidth(disp,screen);
//  screenWidth=64;
  int screenHeight=XDisplayHeight(disp,screen);
//  screenHeight=64;
  int screenX=10;
  int screenY=10;
  int lowerraise=0;
  char picname[1024];
  char title[1024];
  int xl=0;
  int yl=0;
  int store=0;
  int autohidemainbutton=0;
  int MouseMoveOpenSubIcon=0;
  int s_g;
  int last_max_win_id=0;
  char submenue[1000];
  int bord=0;
  char home[1024];
  sprintf(home,"%s",getenv("HOME"));
  Window root_win;
  if ( home == "" )
  {
    printf("fatal error: no /home/xxx found!\n");
    return 1;
  }

  vis = DefaultVisual(disp, DefaultScreen(disp));
  depth = DefaultDepth(disp, DefaultScreen(disp));
  cm = DefaultColormap(disp, DefaultScreen(disp));
  root_win = RootWindow(disp, DefaultScreen(disp));
        // text

   /**
    * Start rendering
    */


//--
  w=screenWidth;
  h=screenHeight;
//  char back_pic[1280];
//  sprintf(back_pic,"%s/.icon-DE/pics/background.png",home);
  
  char usermenufile[1024];
  char result[1024]="";
  char run_mode[1024]="";
  char weather_xywh[60];
  char weather_url[1024];
  int i=0;
  char command[1024]=" ";
  FILE *freeNum;
  char skip[1024]=" ";
  int w_count=0; 
  char w_file[200][1024];
  char rcfile[10]="desk.rc";
  sprintf(usermenufile,"%s/.icon-DE/%s",home,rcfile);
  freeNum=fopen(usermenufile,"r");
  if ( freeNum==NULL)
  { 
    printf("error on open %s\n",usermenufile); 
    exit(1); 
  }
  int gc=0;
  int gd=1;
  char ch;
  char ch2[1024];
  char buffer_rc[1024];
  int n=0;
  int m=0;
  char group[1024]="0";
  int show_sys_inf=0;
  int centered=0;
  int scaled=1;
  int filled=0;
  int time_for_change=10;
  while ( ! feof(freeNum) )
  {
    fgets(buffer_rc,1024,freeNum);
    for (n=0;n<1024;n++)
      if (buffer_rc[n]=='\n') buffer_rc[n]='\0';
        sprintf(command,"");

    if (strcmp(buffer_rc,"")!=0 )
    {
      sprintf(ch2,"%c",buffer_rc[0]);
      if (strcmp(ch2,"#")!=0 ) 
      {
        sprintf(ch2,"%c%c%c%c%c",buffer_rc[0],buffer_rc[1],buffer_rc[2],buffer_rc[3],buffer_rc[4]);
        if (strcmp(ch2,"icon:")==0 )
        {
          for (n=0;n<1019;n++)
          {
             buffer_rc[n]=buffer_rc[n+5];
          } 
          for (n=1018;n<1024;n++)
          {
             buffer_rc[n]='\0';
          }
          sprintf(command,"./iconrun4 %s &",buffer_rc);
          printf("./iconrun4 %s &\n",buffer_rc);
          system(command);
        }  
        sprintf(ch2,"%c%c%c%c%c%c%c",buffer_rc[0],buffer_rc[1],buffer_rc[2],buffer_rc[3],buffer_rc[4],buffer_rc[5],buffer_rc[6]);
        if (strcmp(ch2,"scaled:")==0 )
        {
          for (n=0;n<1024-7;n++)
          {
             buffer_rc[n]=buffer_rc[n+7];
          } 
          for (n=1016;n<1024;n++)
          {
             buffer_rc[n]='\0';
          }
          scaled=atoi(buffer_rc);
        }  
        sprintf(ch2,"%c%c%c%c%c%c%c",buffer_rc[0],buffer_rc[1],buffer_rc[2],buffer_rc[3],buffer_rc[4],buffer_rc[5],buffer_rc[6]);
        if (strcmp(ch2,"filled:")==0 )
        {
          for (n=0;n<1024-7;n++)
          {
             buffer_rc[n]=buffer_rc[n+7];
          } 
          for (n=1016;n<1024;n++)
          {
             buffer_rc[n]='\0';
          }
          filled=atoi(buffer_rc);
        }  
        sprintf(ch2,"%c%c%c%c%c%c%c%c%c",buffer_rc[0],buffer_rc[1],buffer_rc[2],buffer_rc[3],buffer_rc[4],buffer_rc[5],buffer_rc[6],buffer_rc[7],buffer_rc[8]);
        if (strcmp(ch2,"centered:")==0 )
        {
          for (n=0;n<1024-9;n++)
          {
             buffer_rc[n]=buffer_rc[n+9];
          } 
          for (n=1014;n<1024;n++)
          {
             buffer_rc[n]='\0';
          }
          centered=atoi(buffer_rc);
        }  
        sprintf(ch2,"%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c",buffer_rc[0],buffer_rc[1],buffer_rc[2],buffer_rc[3],buffer_rc[4],buffer_rc[5],buffer_rc[6],buffer_rc[7],buffer_rc[8],buffer_rc[9],buffer_rc[10],buffer_rc[11],buffer_rc[12],buffer_rc[13],buffer_rc[14],buffer_rc[15]);
        if (strcmp(ch2,"time_for_change:")==0 )
        {
          for (n=0;n<1024-16;n++)
          {
             buffer_rc[n]=buffer_rc[n+16];
          } 
          for (n=1007;n<1024;n++)
          {
             buffer_rc[n]='\0';
          }
          time_for_change=atoi(buffer_rc);
        }  
        sprintf(ch2,"%c%c%c%c%c%c%c%c%c%c%c%c%c",buffer_rc[0],buffer_rc[1],buffer_rc[2],buffer_rc[3],buffer_rc[4],buffer_rc[5],buffer_rc[6],buffer_rc[7],buffer_rc[8],buffer_rc[9],buffer_rc[10],buffer_rc[11],buffer_rc[12]);
        if (strcmp(ch2,"weather_xywh:")==0 )
        {
          for (n=0;n<1024-13;n++)
          {
             buffer_rc[n]=buffer_rc[n+13];
          } 
          for (n=1010;n<1024;n++)
          {
             buffer_rc[n]='\0';
          }
          sprintf(weather_xywh,"%s",buffer_rc);
        }  
        sprintf(ch2,"%c%c%c%c%c%c%c%c%c%c%c%c",buffer_rc[0],buffer_rc[1],buffer_rc[2],buffer_rc[3],buffer_rc[4],buffer_rc[5],buffer_rc[6],buffer_rc[7],buffer_rc[8],buffer_rc[9],buffer_rc[10],buffer_rc[11]);
        if (strcmp(ch2,"weather_url:")==0 )
        {
          for (n=0;n<1024-11;n++)
          {
             buffer_rc[n]=buffer_rc[n+11];
          } 
          for (n=1011;n<1024;n++)
          {
             buffer_rc[n]='\0';
          }
          sprintf(weather_url,"%s",buffer_rc);
        }  
        sprintf(ch2,"%c%c%c%c%c%c%c%c%c%c%c",buffer_rc[0],buffer_rc[1],buffer_rc[2],buffer_rc[3],buffer_rc[4],buffer_rc[5],buffer_rc[6],buffer_rc[7],buffer_rc[8],buffer_rc[9],buffer_rc[10],buffer_rc[11]);
        if (strcmp(ch2,"wallpapers:")==0 )
        {
          for (n=0;n<1024-11;n++)
          {
             buffer_rc[n]=buffer_rc[n+11];
          } 
          for (n=1011;n<1024;n++)
          {
             buffer_rc[n]='\0';
          }
          sprintf(w_file[w_count],"%s",buffer_rc);
          w_count=w_count+1;
        }  
      } 
    }
  }
  fclose(freeNum);
  n=0;
  while (1)
  {
    srand((int)time(0)); 
    i=random(w_count);
    freeNum=fopen(w_file[i],"r");
    if ( freeNum==NULL)
      printf("error on open %s\n",w_file[i]); 
    else
    {
      fclose(freeNum);
      break;  
    }
    n=n+1;
    if (n>=10 )
      break;
  }    
  back = imlib_load_image(w_file[i]);
  atexit(feh_clean_exit);
  setup_signal_handlers();
  init_parse_options(argc, argv);
  init_imlib_fonts();
  if (opt.display) {
	init_x_and_imlib();
//	init_keyevents();
//	init_buttonbindings();
  }
//  feh_event_init();
//  feh_wm_set_bg_filelist(BG_MODE_FILL);
  feh_wm_set_bg("", back, centered, scaled, filled, 0, 0) ;
  system("killall iconweather");
  sprintf(command,"./iconweather %s %s %s &",weather_xywh,w_file[i],weather_url);
  system(command);
  int xfd = ConnectionNumber(disp);
  fd_set rfds;
  long ticks;

  time_t now_time;
  timeval now, tm,LastTime,LastTime2;
  now_time=time(0);

  
  gettimeofday(&LastTime, 0);
  gettimeofday(&LastTime2, 0);
  
  int s_ch=0;

  while (1)
  {
    if (XPending(disp))
    {
      XNextEvent(disp, &ev);
      switch (ev.type)
      {
        case Expose:

          XSync(disp, False);
          break;
        case MotionNotify:
          x = ev.xmotion.x;
          y = ev.xmotion.y;
        default:
          break;
       case EnterNotify:		
          x = ev.xmotion.x;
          y = ev.xmotion.y;

          break;

       case LeaveNotify:		
//          x = -screenWidth/2;
//          y = -screenHeight/2;	

//          mytoggle = 0;

//          XDestroyWindow(disp,win2);
	
          break;

       case ButtonPress:				
         if(ev.xbutton.button==1)
		{
//            exposelist();
		}
         if(ev.xbutton.button==3)
		{
                                    /* if we click anywhere in the window, exit */
//                                   exit(0);
          break;
        }

      }
    } else {
        //display 是由 XopenDisplay 返回的 Display *
      FD_ZERO(&rfds);
      FD_SET(xfd, &rfds);
      gettimeofday(&now, 0);
      if (s_ch==1)
      {
        s_ch=0;
      }
      ticks=(now.tv_sec-LastTime.tv_sec)*1000+(now.tv_usec-LastTime.tv_usec)/1000;
      if (ticks>=1000*60*time_for_change)
      {
        gettimeofday(&LastTime, 0);
        while (1)
        {
          srand((int)time(0)); 
          i=random(w_count);
          freeNum=fopen(w_file[i],"r");
          if ( freeNum==NULL)
            printf("error on open %s\n",w_file[i]); 
          else
          {
            fclose(freeNum);
            break;  
          }
          n=n+1;
          if (n>=10 )
            break;
        }    
        back = imlib_load_image(w_file[i]);
//        atexit(feh_clean_exit);
//        setup_signal_handlers();
//        init_parse_options(argc, argv);
//        init_imlib_fonts();
//        if (opt.display) {
//          init_x_and_imlib();
        feh_wm_set_bg("", back, centered, scaled, filled, 0, 0) ;
        system("killall iconweather");
        sprintf(command,"./iconweather %s %s %s &",weather_xywh,w_file[i],weather_url);
        system(command);
//      }
//      ticks=(now.tv_sec-LastTime2.tv_sec)*1000+(now.tv_usec-LastTime2.tv_usec)/1000;
//      if (ticks>=1000*find_win_time)
//      {
//        if (list_windows(disp,skip)!=EXIT_FAILURE)
//        {
//          if (last_max_win_id!=max_win_id)
//          {
//            gettimeofday(&LastTime2, 0);
//          }  
//        }
//      }
//如果到期则调用有关函数
//select 等待 100 毫秒
      tm.tv_sec=0l;
      tm.tv_usec=100000l;
      select(xfd + 1, &rfds, 0, 0, &tm);
    } /* End else*/
  }

}

   return 0;
}

